/*
Written By Siva
Www.sql-articles.com
*/
/* Step : 1 --> To create sample DB and table with recovery model as Bulk_Logged */
Set NoCount On
Go
Use Master
if db_id('bulkOperations') is not null
drop database bulkOperations
Go
create database bulkOperations
Go
Alter Database bulkOperations Set Recovery Bulk_Logged
Go
USe bulkOperations
GO
Create Table tblBulkOperations (sno int identity(1,1), Comments char(8000))
Go
Create Table tblBulkOperations_bcp (sno int , Comments char(8000))
GO
select 	'Step 1: initial size of Log File', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2

GO

/* Step : 2 --> Inserting records [row by row method] */

insert into tblBulkOperations values('Just 4 testing')
Go 8000
Go
select 	'Step 2: After 8000 Rows Insertion [by using ordinary insert method]', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2
GO

/* Step : 3 --> Bulk Insert [by using select into clause] */

select	* into tblBulkOperations_into
From	tblBulkOperations
Go
select 	'Step 3: Bulk Insert [by using select into clause]', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2
Go


/* Step : 4 -->  bulk Insertion  by using ordinary select */

insert into tblBulkOperations_into(Comments)
select Comments From	tblBulkOperations
Go  

select 	'Step 4: bulk Insertion  by using ordinary select', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2

Go

/* Step : 5 -->  bulk Insertion  by using BCP */

xp_cmdShell 'bcp "SELECT * FROM bulkOperations.dbo.tblBulkOperations_into" queryout tblBulkOperations.dat -T -c -o ee.log'
GO

xp_cmdShell 'bcp bulkOperations.dbo.tblBulkOperations_bcp in tblBulkOperations.dat -T -c -o ee.log'
GO

select 	'Step 5: bulk Insertion  by using BCP', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2
GO
/* Step : 6 -->  Bulk Update*/
GO
Alter table tblBulkOperations_bcp add cid varchar(10)
GO
Update tblBulkOperations_bcp
Set cid=left(Comments,3) + convert(varchar(10),sno)
GO
select 	'Step 6: Bulk Update', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2
GO

/* Step : 7 -->  Create Index */
create clustered index idx_tblBulkOperations_bcp on tblBulkOperations_bcp (sno,cid)
GO

select 	'Step 7: Create Index', 
		'Log File size' = convert(nvarchar(15) ,
		convert (bigint, size) * 8) ,getdate() EndTime
from	sysfiles
where	[fileid]=2
GO
USE master